import pyodbc
import csv
import random
from pprint import pprint

server = 'tcp:apa.di.unipi.it' 
database = 'FoodMart' 
username = 'lbi' 
password = 'pisa' 
connectionString = 'DRIVER={ODBC Driver 17 for SQL Server};SERVER='+server+';DATABASE='+database+';UID='+username+';PWD='+ password
cnxn = pyodbc.connect(connectionString)

males = set()
females = set()
query = "SELECT * FROM customer"
cursor = cnxn.cursor()
cursor.execute(query)
for row in cursor:
    if row.gender == "F":
        females.add(row.customer_id)
    else:
        males.add(row.customer_id)
cursor.close()

jan1998 = set()
jul1998 = set()
query = "SELECT * FROM time_by_day"
cursor = cnxn.cursor()
cursor.execute(query)   
for row in cursor:
    if row.the_year == 1998:
        if row.the_month == "January":
            jan1998.add(row.time_id)
        elif row.the_month == "July":
            jul1998.add(row.time_id)
cursor.close()

query = "SELECT * FROM sales_fact"
cursor = cnxn.cursor()
cursor.execute(query)
product_store_res = dict()
for row in cursor:
    p_id = row.product_id
    t_id = row.time_id
    s_id = row.store_id
    c_id = row.customer_id
    if p_id not in product_store_res:
        product_store_res[p_id] = dict()
	#foreach product and store compute set of females, 
	#set of males, Jan sales, June_sales
	
    if s_id not in product_store_res[p_id]:
        product_store_res[p_id][s_id] = {"fem":set(),"mal":set(),"jan":0,"jul":0}
    res = product_store_res[p_id][s_id]
    if c_id in females:
        res["fem"].add(c_id)
    elif c_id in males:
        res["mal"].add(c_id)
    if t_id in jan1998:
        res["jan"] += row.store_sales
    elif t_id in jul1998:
        res["jul"] += row.store_sales
cursor.close()

product_store_ratios = dict()
for product in product_store_res:
    product_store_ratios[product] = dict()
    for store in product_store_res[product]:
        res = product_store_res[product][store]
        if len(res["mal"]) == 0:
            a_b = 0
        else:
            a_b = len(res["fem"])/len(res["mal"])
        if res["jul"] == 0:
            c_d = 0
        else:
            c_d = res["jan"]/res["jul"]
        product_store_ratios[product][store] = {"a/b":a_b,"c/d":c_d}

with open("results.csv","w+") as f:
    f.write("product,store,a/b,c/d\n")
    for product in product_store_ratios:
        for store in product_store_ratios[product]:
            res = product_store_ratios[product][store]
            f.write(str(product)+","+str(store)+","+str(res["a/b"])+","+str(res["c/d"])+"\n")